View Issue Details

IDProjectCategoryView StatusLast Update
0034753LazarusDebuggerpublic2019-02-26 19:53
ReporterVojtech CihakAssigned ToMartin Friebe 
PrioritynormalSeverityminorReproducibilityalways
Status closedResolutionfixed 
Platformamd64OSLinuxOS VersionChakra 64-bit
Product Version2.1 (SVN)Product Build59879 
Target Version2.2Fixed in Version2.2 
Summary0034753: FPDebug highlights wrong lines on crash
DescriptionFPDebug highlights wrong lines on crash.

unit Unit1;
{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, StdCtrls;

type
  { TForm1 }
  TForm1 = class(TForm)
    procedure FormClick(Sender: TObject);
  private
    procedure AAA;
    procedure BBB;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.AAA;
var i: Integer;
    l: TLabel;
begin
  i:=1;
  l.caption:='abc';
  i:=2;
end;

procedure TForm1.BBB;
var i: Integer;
begin
  i:=1;
  AAA;
  i:=2;
end;

procedure TForm1.FormClick(Sender: TObject);
var i: Integer;
begin
  i:=1;
  BBB;
  i:=2;
end;

end.
Steps To ReproduceSet Debugger to FPDebug in Options. Open Call Stack window. Run project. Click the form. Now project crashes.
Click the relevant line in Call Stack window.
While with GDB it highlights the correct lines, with FPDebug it highlights the next lines (i:=2;).


Additional InformationLazarus 2.1.0 r59879 FPC 3.3.1 x86_64-linux-qt
TagsNo tags attached.
Fixed in Revision59978
LazTarget2.2
Widgetset
Attached Files

Activities

Vojtech Cihak

2018-12-22 17:59

reporter  

FPDebugLine.zip (2,340 bytes)

Martin Friebe

2018-12-22 19:50

manager   ~0112820

It does not even need a crash. Most stackframes will highlight the next line at current.

Martin Friebe

2019-01-03 01:14

manager   ~0113123

Fixed in r59978
Please test and close if ok.

This only affects Pascal Source code lines. The asm window will show the command after the "call".

Vojtech Cihak

2019-02-26 19:53

reporter   ~0114469

Works. Thanks.

Issue History

Date Modified Username Field Change
2018-12-22 17:59 Vojtech Cihak New Issue
2018-12-22 17:59 Vojtech Cihak Status new => assigned
2018-12-22 17:59 Vojtech Cihak Assigned To => Martin Friebe
2018-12-22 17:59 Vojtech Cihak File Added: FPDebugLine.zip
2018-12-22 19:50 Martin Friebe Note Added: 0112820
2019-01-03 01:14 Martin Friebe Fixed in Revision => 59978
2019-01-03 01:14 Martin Friebe LazTarget => 2.2
2019-01-03 01:14 Martin Friebe Note Added: 0113123
2019-01-03 01:14 Martin Friebe Status assigned => resolved
2019-01-03 01:14 Martin Friebe Fixed in Version => 2.2
2019-01-03 01:14 Martin Friebe Resolution open => fixed
2019-01-03 01:14 Martin Friebe Target Version => 2.2
2019-02-26 19:53 Vojtech Cihak Note Added: 0114469
2019-02-26 19:53 Vojtech Cihak Status resolved => closed